'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = getTimeoutFetch;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function getTimeoutFetch(fetch, timeout) {
  var timeoutFetch = void 0;
  if (fetch.polyfill) {
    timeoutFetch = function timeoutFetch(request) {
      return fetch(request, {
        timeout: timeout
      });
    };
  } else {
    timeoutFetch = function timeoutFetch(request) {
      return new _promise2.default(function (resolve, reject) {
        var timeout = setTimeout(function () {
          reject(new TypeError('Network request timeout'));
        }, timeout);
        fetch(request).then(function (response) {
          clearTimeout(timeout);
          resolve(response);
        }).catch(function (err) {
          clearTimeout(timeout);
          reject(err);
        });
      });
    };
  }
  return timeoutFetch;
}