'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require('babel-runtime/helpers/asyncToGenerator');

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _interceptor = require('./interceptor');

var _interceptor2 = _interopRequireDefault(_interceptor);

var _transformResponse = require('../util/transformResponse');

var _transformResponse2 = _interopRequireDefault(_transformResponse);

var _checkStatus = require('../util/checkStatus');

var _checkStatus2 = _interopRequireDefault(_checkStatus);

var _timeout = require('./timeout');

var _timeout2 = _interopRequireDefault(_timeout);

var _promiseTask = require('./promiseTask');

var _promiseTask2 = _interopRequireDefault(_promiseTask);

var _buildSearchParams = require('../util/buildSearchParams');

var _buildSearchParams2 = _interopRequireDefault(_buildSearchParams);

var _types = require('../util/types');

var _baseUrl = require('../util/baseUrl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var zyFetch = function () {
  function zyFetch(config, fetch) {
    (0, _classCallCheck3.default)(this, zyFetch);

    this.config = config;
    this.nativeFetch = fetch;
    this.interceptors = {
      request: new _interceptor2.default(),
      response: {
        transform: new _interceptor2.default(),
        noTransform: new _interceptor2.default()
      }
    };
  }

  (0, _createClass3.default)(zyFetch, [{
    key: 'send',
    value: function send(init) {
      var option = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

      var config = {};
      // merge config
      (0, _assign2.default)(config, this.config, option);
      var request = this._getRequest(init, config);

      var promiseTask = new _promiseTask2.default();
      this._initPromiseTask(promiseTask, config);
      return promiseTask.execute(request);
    }
  }, {
    key: 'get',
    value: function get(init, option) {
      option = this._methodsOptionMerge(option, 'get');
      return this.send(init, option);
    }
  }, {
    key: 'delete',
    value: function _delete(init, option) {
      option = this._methodsOptionMerge(option, 'get');
      return this.send(init, option);
    }
  }, {
    key: 'options',
    value: function options(init, option) {
      option = this._methodsOptionMerge(option, 'get');
      return this.send(init, option);
    }
  }, {
    key: 'head',
    value: function head(init, option) {
      option = this._methodsOptionMerge(option, 'get');
      return this.send(init, option);
    }
  }, {
    key: 'post',
    value: function post(init, body, option) {
      option = this._methodsOptionMerge(option, 'post', body);
      return this.send(init, option);
    }
  }, {
    key: 'put',
    value: function put(init, body, option) {
      option = this._methodsOptionMerge(option, 'put', body);
      return this.send(init, option);
    }
  }, {
    key: 'patch',
    value: function patch(init, body, option) {
      option = this._methodsOptionMerge(option, 'patch', body);
      return this.send(init, option);
    }

    /**
     *
     * @param fetchs some fetch
     * @returns {Promise.<*[]>} return promise
     */

  }, {
    key: 'all',
    value: function all(fetchs) {
      return _promise2.default.all(fetchs);
    }

    /**
     * Execute fetch in sequence
     * @param fetchs some fetch
     */

  }, {
    key: 'allByOrder',
    value: function () {
      var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(fetchs) {
        var responseArray, i, response;
        return _regenerator2.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                responseArray = [];
                i = 0;

              case 2:
                if (!(i < fetchs.length)) {
                  _context.next = 10;
                  break;
                }

                _context.next = 5;
                return fetchs[i].call(this);

              case 5:
                response = _context.sent;

                responseArray.push(response);

              case 7:
                i++;
                _context.next = 2;
                break;

              case 10:
                return _context.abrupt('return', _promise2.default.resolve(responseArray));

              case 11:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function allByOrder(_x2) {
        return _ref.apply(this, arguments);
      }

      return allByOrder;
    }()

    /**
     * 将函数的数组参数解构 [1,2,3] => 1,2,3
     * @param cb
     * @returns {Function}
     */

  }, {
    key: 'spread',
    value: function spread(cb) {
      return function (args) {
        cb.apply(null, args);
      };
    }
  }, {
    key: '_initPromiseTask',
    value: function _initPromiseTask(promiseTask, config) {
      var interceptors = this.interceptors;
      // set request promise
      interceptors.request.forEach(function (interceptor) {
        promiseTask.add(interceptor.onFulfilled, interceptor.onRejected);
      });
      //set timeout
      if (config.timeout && config.timeout > 0) {
        promiseTask.add((0, _timeout2.default)(this.nativeFetch, config.timeout));
      } else {
        promiseTask.add(this.nativeFetch);
      }

      //set checkStatus promise
      promiseTask.add(_checkStatus2.default);

      //set before transform response interceptors promise
      interceptors.response.noTransform.forEach(function (interceptor) {
        promiseTask.add(interceptor.onFulfilled, interceptor.onRejected);
      });

      //set transform response promise
      if (config.transformResponse) {
        promiseTask.add(_transformResponse2.default.bind(this, config.responseType));
        // set after transform response promise
        interceptors.response.transform.forEach(function (interceptor) {
          promiseTask.add(interceptor.onFulfilled, interceptor.onRejected);
        });
      }
    }
  }, {
    key: '_methodsOptionMerge',
    value: function _methodsOptionMerge() {
      var option = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
      var method = arguments[1];
      var body = arguments[2];

      (0, _assign2.default)(option, {
        method: method,
        body: body
      });
      return option;
    }
  }, {
    key: '_getRequest',
    value: function _getRequest(init, config) {
      var url = init.url ? init.url : init;
      if (config.baseUrl && !(0, _baseUrl.isAbsoluteURL)(url)) {
        url = (0, _baseUrl.buildAbsoluteURL)(config.baseUrl, url);
      }
      if (config.params) {
        url = (0, _buildSearchParams2.default)(url, config.params);
      }
      if (init instanceof Request) {
        return this._mergeRequest(url, init, config);
      }
      return new Request(url, config);
    }
  }, {
    key: '_mergeRequest',
    value: function _mergeRequest(url, request, config) {
      var copyRequest = {};
      //copy request props, but body can not get, so request.body will be ignore
      for (var key in request) {
        var val = request[key];
        if (!(0, _types.isFunction)(val)) {
          copyRequest[key] = val;
        }
      }
      (0, _assign2.default)(copyRequest, config);
      return new Request(url, copyRequest);
    }
  }]);
  return zyFetch;
}();

exports.default = zyFetch;