'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.fetch = undefined;

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _getOwnPropertyNames = require('babel-runtime/core-js/object/get-own-property-names');

var _getOwnPropertyNames2 = _interopRequireDefault(_getOwnPropertyNames);

var _setPrototypeOf = require('babel-runtime/core-js/object/set-prototype-of');

var _setPrototypeOf2 = _interopRequireDefault(_setPrototypeOf);

exports.createInstance = createInstance;

var _zyFetch = require('./core/zyFetch');

var _zyFetch2 = _interopRequireDefault(_zyFetch);

var _config = require('./core/config');

var _config2 = _interopRequireDefault(_config);

require('./fetch/fetch-polyfill');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// native fetch
var nativeFetch = self.fetch;

function createInstance(option) {
  var zy = new _zyFetch2.default(option, nativeFetch);
  var instance = proxy(zy.send, zy);

  function proxy(fn, thisArgs) {
    return function (init, option) {
      return fn.call(thisArgs, init, option);
    };
  }

  // extend method
  (0, _setPrototypeOf2.default)(instance, _zyFetch2.default.prototype);
  // extend own prop
  (0, _getOwnPropertyNames2.default)(zy).forEach(function (name) {
    instance[name] = zy[name];
  });
  return instance;
}

var zyFetch = createInstance(_config2.default);

zyFetch.create = function () {
  var config = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var option = {};
  (0, _assign2.default)(option, _config2.default, config);
  return createInstance(option);
};

exports.fetch = zyFetch;


if (typeof window !== 'undefined' && typeof self !== 'undefined') {
  self.fetch = zyFetch;
}