'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

exports.default = buildSearchParams;

var _types = require('./types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function encode(val) {
  return encodeURIComponent(val).replace(/%40/gi, '@').replace(/%3A/gi, ':').replace(/%24/g, '$').replace(/%2C/gi, ',').replace(/%20/g, '+').replace(/%5B/gi, '[').replace(/%5D/gi, ']');
}

function buildSearchParams(url, params) {
  if (!params) {
    return url;
  }
  var searchParams = [];
  (0, _keys2.default)(params).forEach(function (key) {
    var value = params[key];
    if (Array.isArray(value)) {
      key = key + '[]';
    } else {
      value = [value];
    }

    value.forEach(function (val) {
      if ((0, _types.isDate)(val)) {
        val = val.toISOString();
      } else if ((0, _types.isObject)(val)) {
        val = (0, _stringify2.default)(val);
      }
      searchParams.push(encode(key) + '=' + encode(val));
    });
  });
  searchParams = searchParams.join('&');
  if (searchParams.length > 0) {
    url += (url.indexOf('?') === -1 ? '?' : '&') + searchParams;
  }
  return url;
}