'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

exports.default = transformResponse;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function transformResponse(responseType, response) {
  switch (responseType) {
    case 'json':
      {
        return response.json().then(function (res) {
          if (typeof res === 'string') {
            return JSON.parse(res);
          } else {
            return res;
          }
        });
      }
    case 'blob':
      {
        return response.blob();
      }
    case 'text':
      {
        return response.text();
      }
    case 'arrayBuffer':
      {
        return response.arrayBuffer();
      }
    case 'formData':
      {
        return response.formData();
      }
    default:
      {
        return _promise2.default.resolve(response);
      }
  }
}